<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRow(modalDatos)" class="btn btn-primary">
    <i class="fa fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="!dataGrid">
    <i class="far fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="main-card mb-3 card">
    <div class="card-body">

        <div *ngIf="!loading">

            <kendo-grid [data]="dataGrid"
                        [filter]="filter"
                        [filterable]="true"
                        (filterChange)="filterChange($event)"
                        [selectable]="true"
                        [navigable]="true"
                        [reorderable]="true"
                        [resizable]="true"
                        [sort]="sort"
                        [sortable]="true"
                        (sortChange)="sortChange($event)"
                        [groupable]="true" [group]="groups"
                        (groupChange)="groupChange($event)"
                        (edit)="editRow($event, modalDatos)"
                        (remove)="deleteRow($event)"
                        style="height: 69vh">

                <div *ngIf="dataGrid.length !== 0">

                    <div *ngFor="let item of gridFields">
                        <kendo-grid-column [field]="item.dataKey" [title]="item.title" [width]="item.width"
                                           [filterable]="item.filtro">
                        </kendo-grid-column>
                    </div>
                    <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
                        <ng-template kendoGridFilterCellTemplate>
                            <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked"
                                          onLabel="Si">
                            </kendo-switch>
                        </ng-template>
                        <ng-template kendoGridCellTemplate let-dataItem>
                            <input type="checkbox" [checked]="dataItem.Inactivo" disabled/>
                        </ng-template>
                    </kendo-grid-column>
                    <kendo-grid-command-column title="Actions" width="190">
                        <ng-template kendoGridCellTemplate let-isNew="isNew">
                            <button kendoGridEditCommand [primary]="true">Editar</button>
                            <button kendoGridRemoveCommand>Eliminar</button>
                        </ng-template>
                    </kendo-grid-command-column>

                </div>

                <ng-template kendoGridNoRecordsTemplate>
                    {{ norecords }}
                </ng-template>
            </kendo-grid>

        </div>

        <app-loading *ngIf="loading"></app-loading>

    </div>
</div>

<ng-template #modalDatos let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h4 class="modal-title" *ngIf="!flagEdit">Nuevo</h4>
        <h4 class="modal-title" *ngIf="flagEdit">Editar</h4>
        <button type="button" class="close" aria-label="Close" (click)="d('Cross click')">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <form [formGroup]="myFormGroup" class="k-form">
                <div class="row">
                    <div class="k-form-field col-8">
                        <label>Trabajo</label>
                        <input type="text" class="k-textbox" name="trabajo"
                               [(ngModel)]="myFormGroup.value.trabajo"
                               formControlName="trabajo" [readOnly]="flagEdit" maxlength="3"/>
                    </div>
                    <div class="k-form-field col-4 text-right">
                        <label>Inactivo</label>
                        <kendo-switch name="Inactivo" [(ngModel)]="myFormGroup.value.Inactivo"
                                      formControlName="Inactivo"
                                      [onLabel]="'Si'" [offLabel]="'No'" style="float: right;">
                        </kendo-switch>
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <label>Descripción</label>
                        <input type="text" class="k-textbox" name="tdesc" [(ngModel)]="myFormGroup.value.tdesc"
                               formControlName="tdesc"
                               maxlength="30">
                    </div>
                </div>
                <div class="row">
                    <div class="col-12">
                        <label class="mt-2">Tipo</label>
                        <kendo-combobox [data]="tipoTT" [(ngModel)]="myFormGroup.value.TT" [textField]="'title'"
                                        [valueField]="'dataKey'" [valuePrimitive]="true"
                                        [filterable]="true" formControlName="TT" name="TT" class="w-100">
                        </kendo-combobox>
                    </div>
                </div>
        </form>
    </div>
    <div class="modal-footer">
      <button class="btn btn-success" (click)="guardarForm(); c();"
      [disabled]="myFormGroup.invalid">
        <i class="fas fa-save mr-2"></i>Guardar
      </button>
      <button class="btn btn-secondary" (click)="closeForm(); c('Close click')">Cerrar</button>
    </div>
</ng-template>
